function T3=tadll(T2,xf,xa,fmCO2,fmCO,fmH2,fmH2O,fmO2,fmN2)
R=8.314472;
mmolCO2=44.0095e-3;
mmolCO=28.0101e-3;
mmolH2=2.01588e-3;
mmolH2O=18.01528e-3;
mmolO2=31.9988e-3;
mmolN2=28.1610e-3;
mmolarAir=28.9651159e-3;
mmolarf=114.22852d-3;
qvi=5109178.5;
qpi=5100502.0;
qviCO=281747.5;
qpiCO=282987.0;
qviH2=240587.5;
qpiH2=241824.0;

auxR=xf/mmolarf*(hf(T2)-R*(T2-298.15)+qvi)+xa/mmolarAir*(hAir(T2)-R*(T2-298.15));
a=201;
b=5999;
ga=fmCO2*(hCO2(a)-R*(a-298.15))/mmolCO2+fmCO*(hCO(a)-R*(a-298.15)+qviCO)/mmolCO+fmH2*(hH2(a)-R*(a-298.15)+qviH2)/mmolH2+fmH2O*(hH2O(a)-R*(a-298.15))/mmolH2O+fmO2*(hO2(a)-R*(a-298.15))/mmolO2+fmN2*(hN2(a)-R*(a-298.15))/mmolN2-auxR;
gb=fmCO2*(hCO2(b)-R*(b-298.15))/mmolCO2+fmCO*(hCO(b)-R*(b-298.15)+qviCO)/mmolCO+fmH2*(hH2(b)-R*(b-298.15)+qviH2)/mmolH2+fmH2O*(hH2O(b)-R*(b-298.15))/mmolH2O+fmO2*(hO2(b)-R*(b-298.15))/mmolO2+fmN2*(hN2(b)-R*(b-298.15))/mmolN2-auxR;
err=abs(ga-gb);
while err>1.e-6
T3=(a+b)/2;
ga=fmCO2*(hCO2(a)-R*(a-298.15))/mmolCO2+fmCO*(hCO(a)-R*(a-298.15)+qviCO)/mmolCO+fmH2*(hH2(a)-R*(a-298.15)+qviH2)/mmolH2+fmH2O*(hH2O(a)-R*(a-298.15))/mmolH2O+fmO2*(hO2(a)-R*(a-298.15))/mmolO2+fmN2*(hN2(a)-R*(a-298.15))/mmolN2-auxR;
gb=fmCO2*(hCO2(b)-R*(b-298.15))/mmolCO2+fmCO*(hCO(b)-R*(b-298.15)+qviCO)/mmolCO+fmH2*(hH2(b)-R*(b-298.15)+qviH2)/mmolH2+fmH2O*(hH2O(b)-R*(b-298.15))/mmolH2O+fmO2*(hO2(b)-R*(b-298.15))/mmolO2+fmN2*(hN2(b)-R*(b-298.15))/mmolN2-auxR;
gTad=fmCO2*(hCO2(T3)-R*(T3-298.15))/mmolCO2+fmCO*(hCO(T3)-R*(T3-298.15)+qviCO)/mmolCO+fmH2*(hH2(T3)-R*(T3-298.15)+qviH2)/mmolH2+fmH2O*(hH2O(T3)-R*(T3-298.15))/mmolH2O+fmO2*(hO2(T3)-R*(T3-298.15))/mmolO2+fmN2*(hN2(T3)-R*(T3-298.15))/mmolN2-auxR;
	if ga*gTad<=0
		b=T3;
	else
		a=T3;
	end
err=abs(ga-gb);
end
